<?php
//error_reporting(E_ALL);
include('adodb/adodb.inc.php');
include('config.inc.php');

// define all the SQL Connections
$db_eqdkp = &ADONewConnection('mysql');
$db_roster = &ADONewConnection('mysql');

// Enable SQL Debugging
if ($sqldebug) {
	$db_eqdkp->debug = true;
	$db_roster->debug = true;
}

// Initialize an ErrorArray to catch errors when NOT in debug
if (!$debug) {
	$errorarray = array();
	$errorcount = 0;
}

// Connect all the databases
$db_eqdkp->NConnect($eqdkp_host, $eqdkp_user, $eqdkp_password, $eqdkp_db);
$db_roster->NConnect($roster_host, $roster_user, $roster_password, $roster_db);

//Grab the arrays of EQDKP
$rseqdkp_classes = $db_eqdkp->Execute('SELECT class_id, class_name, class_min_level, class_max_level FROM '.$eqdkp_prefix.'classes');
$eqdkp_classes = $rseqdkp_classes->GetArray();
$rseqdkp_races = $db_eqdkp->Execute('SELECT race_id, race_name FROM '.$eqdkp_prefix.'races');
$eqdkp_races = $rseqdkp_races->GetArray();

//// Execute the functions
SyncGuildRanks();
SyncRosterMembers();

// Close all DB COnnections
$db_eqdkp->Close();
$db_roster->Close();

// Display errors when NOT in Debug mode
if (!$debug) {
	if ($errorcount > 0) {
		foreach ($errorarray as $error) {
			echo $error;
		}
	}
}

// Verify the Class Name and Level, and return the EQDKP Class ID
function checkclass($classname, $level) {
	global $eqdkp_classes;
	$returnvalue = 0;
	foreach ($eqdkp_classes as $class) {
		if ($classname == $class['class_name'] && $class['class_min_level'] <= $level && $level <= $class['class_max_level']) {
			$returnvalue = $class['class_id'];
		}
	}
	return $returnvalue;
}

// Verify the Race Name, and return the EQDKP Race ID
function checkrace($racename) {
	global $eqdkp_races;
	$returnvalue = 0;
	foreach ($eqdkp_races as $race) {
		if ($racename == $race['race_name']) {
			$returnvalue = $race['race_id'];
		}
	}
	return $returnvalue;
}

	//// Process the GuildRank sync between Roster and EQDKP
function SyncGuildRanks() {
	// Grab the Globals
	global $debug, $db_eqdkp, $db_roster, $eqdkp_prefix, $roster_prefix, $roster_guildid, $eqdkp_classes, $eqdkp_races;
	
	// Get a new EQDKP GuildRank Record
	$newrecordranksql = "SELECT * FROM " . $eqdkp_prefix . "member_ranks WHERE rank_id = -1";
	$newrecordrank = $db_eqdkp->Execute($newrecordranksql); // Execute the query and get the empty recordset
	
	// Grab the Roster's Ranks and fill them into EQDKP
	$rsRoster_GuildRanks =& $db_roster->query('SELECT guild_rank, guild_title FROM '.$roster_prefix.'members WHERE guild_id='.$roster_guildid.' GROUP BY guild_title');
	$Roster_GuildRanks = $rsRoster_GuildRanks->GetArray();
	foreach ($Roster_GuildRanks as $guildrank) {
		if ($debug) {
			echo "################################################################################################################################<BR>";
			echo "# RST> Processesing Roster GuildRank with guild_rank: " . $guildrank['guild_rank'] . " and guild_title: " . utf8_decode($guildrank['guild_title']) . " <BR>";
		}
		$insertrosterrank = array(); # Initialize an array to hold the record data to insert
		// Set the values for the fields in the record
		if ($guildrank['guild_rank'] == 0) {
			$insertrosterrank['rank_id'] = 999;
		} else {
			$insertrosterrank['rank_id'] = $guildrank['guild_rank'];
		}
		$insertrosterrank['rank_name'] = utf8_decode($guildrank['guild_title']);
		
			// Pass the empty recordset and the array containing the data to insert into the GetInsertSQL function.
		$EQDKPinsertRankSQL = $db_eqdkp->GetInsertSQL($newrecordrank, $insertrosterrank);
		if ($debug) {
			echo "<span style=\"color: blue;\"><b>################################################################################################################################</b></span><BR>";
			echo "<span style=\"color: blue;\"><b># SQL></b> Inserting NEW ROW for rank_name: <b>" . $insertrosterrank['rank_name'] . "</b> with rank_id: </b>" . $insertrosterrank['rank_id'] . "</b></span><BR>";
		}
		if ($db_eqdkp->Execute($EQDKPinsertRankSQL) === false) {
			if ($debug) {
				echo "<span style=\"color: blue;\"><b># SQL></b> rank_name: <b>" . $insertrosterrank['rank_name'] . "</b> with rank_id: </b>" . $insertrosterrank['rank_id'] . " already exists</b></span><BR>";
			}
			if ($db_eqdkp->ErrorMsg() == "Duplicate entry '" . $insertrosterrank['rank_id'] . "' for key 1") {
				if ($debug) {
					echo "<span style=\"color: blue;\"><b># SQL> Error Message: " . $db_eqdkp->ErrorMsg() . "</b></span><BR>";
					echo "<span style=\"color: blue;\"></b># SQL> The rank_id: <b>" . $insertrosterrank['rank_id'] . "</b> DOES already Exist, attempting Updating of the record....</span><BR>";
				}
				// Trying to update the record rather than inserting it...
				$existingrecordranksql = "SELECT * FROM " . $eqdkp_prefix . "member_ranks WHERE rank_id='" . $insertrosterrank['rank_id'] . "'";
				$existingrecordrank = $db_eqdkp->Execute($existingrecordranksql); # Execute the query and get the empty recordset
				$EQDKPupdateRankSQL = $db_eqdkp->GetUpdateSQL($existingrecordrank, $insertrosterrank);
				if ($db_eqdkp->Execute($EQDKPupdateRankSQL) === false) {
					if ($debug) {
						if ($db_eqdkp->ErrorMsg() == "Query was empty") {
							echo "<span style=\"color: blue;\"><b># SQL> Error Message: " . $db_eqdkp->ErrorMsg() . "</b></span><BR>";
							echo "<span style=\"color: blue;\"><b># SQL></b> The record for rank_id: <b>" . $insertrosterrank['rank_id'] . "</b>, rank_name: <b>" . $insertrosterrank['rank_name'] . "</b> was not updated <b>>>> SAME <<<<</b><BR></span><BR>";
						} else {
							echo "<span style=\"color: red;\"><b># SQL> Error Message: " . $db_eqdkp->ErrorMsg() . "</b></span><BR>";
						}
					} elseif ($db_eqdkp->ErrorMsg() != "Query was empty") {
						$errorarray[$errorcount] = "<span style=\"color: red;\"><b># SQL> Error Message: " . $db_eqdkp->ErrorMsg() . "</b></span><BR>";
						$errorcount++;
					}
				} else {
					if ($debug) {
						echo "<span style=\"color: green;\"><b># SQL> The Record was succesfully updated for rank_id: <b>" . $insertrosterrank['rank_id'] . "</b>, rank_name: <b>" . $insertrosterrank['rank_name'] . ".</b></span><BR>";
					}
				}
			}
		} else {
			if ($debug) {
				echo "<span style=\"color: green;\"><b># SQL> The Record was succesfully inserted for rank_id: <b>" . $insertrosterrank['rank_id'] . "</b>, rank_name: <b>" . $insertrosterrank['rank_name'] . ".</b></span><BR>";
			}
		}
	}
}

function SyncRosterMembers() {
	//// Process the Member sync between Roster and EQDKP
	
	// Grabbing the Globals
	global $debug, $db_eqdkp, $db_roster, $eqdkp_prefix, $roster_prefix, $roster_guildid, $eqdkp_classes, $eqdkp_races;	
	
	// Get a new EQDKP User Record
	$newrecordsql = "SELECT * FROM " . $eqdkp_prefix . "members WHERE member_id = -1";
	$newrecord = $db_eqdkp->Execute($newrecordsql); // Execute the query and get the empty recordset
	
	// Grab the Roster Members and Insert them into the EQDKP database. Update the record with Rank and Level if it already exists.
	$rsRoster_Members = $db_roster->Execute('SELECT member_id, name, class, level, guild_rank FROM '.$roster_prefix.'members WHERE guild_id='.$roster_guildid);
	$Roster_Members = $rsRoster_Members->GetArray();
	foreach ($Roster_Members as $rostermember) {
		if ($debug) {
			echo "################################################################################################################################<BR>";
			echo "# RST> Processesing Roster Member with member_id: " . $rostermember['member_id'] . " and Name: " . utf8_decode($rostermember['name']) . " <BR>";
		}
		$insertrosterrecord = array(); # Initialize an array to hold the record data to insert
		// Set the values for the fields in the record
		// $rostermember['member_id'];
		$insertrosterrecord['member_name'] = utf8_decode($rostermember['name']);
		if (utf8_decode($rostermember['guild_rank']) == 0) {
			$insertrosterrecord['member_rank_id'] = 999;
		} else {
			$insertrosterrecord['member_rank_id'] = $rostermember['guild_rank'];
		}
		$insertrosterrecord['member_level'] = $rostermember['level'];
		$insertrosterrecord['member_class'] =	utf8_decode($rostermember['class']);
		$insertrosterrecord['member_class_id'] = checkclass (utf8_decode($rostermember['class']), $rostermember['level']);
		$rosterrace = $db_roster->Execute('SELECT race FROM '.$roster_prefix.'players WHERE member_id='.$rostermember['member_id']);
		if ($racerow = $rosterrace->FetchRow()) {
	  	$insertrosterrecord['member_race_id'] = checkrace($racerow['race']);
		} else {
			$insertrosterrecord['member_race_id'] = 0;
		}
		
		// Pass the empty recordset and the array containing the data to insert into the GetInsertSQL function.
		$EQDKPinsertSQL = $db_eqdkp->GetInsertSQL($newrecord, $insertrosterrecord);
		if ($debug) {
			echo "<span style=\"color: blue;\"><b>################################################################################################################################</b></span><BR>";
			echo "<span style=\"color: blue;\"><b># SQL></b> Inserting NEW ROW for member_name: <b>" . $insertrosterrecord['member_name'] . "</b> with roster member_id: </b>" . $rostermember['member_id'] . "</b></span><BR>";
		}
		if ($db_eqdkp->Execute($EQDKPinsertSQL) === false) {
			if ($db_eqdkp->ErrorMsg() == "Duplicate entry '" . $insertrosterrecord['member_name'] . "' for key 2") {
				if ($debug) {
					echo "<span style=\"color: blue;\"><b># SQL></b> member_name: <b>" . $insertrosterrecord['member_name'] . "</b> already exists</span><BR>";
				}
				// Trying to update the record rather than inserting it...
				$existingrecordsql = "SELECT * FROM " . $eqdkp_prefix . "members WHERE member_name='" . $insertrosterrecord['member_name'] . "'";
				$existingrecord = $db_eqdkp->Execute($existingrecordsql); # Execute the query and get the empty recordset
				$EQDKPupdateSQL = $db_eqdkp->GetUpdateSQL($existingrecord, $insertrosterrecord);
				if ($db_eqdkp->Execute($EQDKPupdateSQL) === false) {
					if ($debug) {
						if ($db_eqdkp->ErrorMsg() == "Query was empty") {
							echo "<span style=\"color: blue;\"><b># SQL> Error Message: " . $db_eqdkp->ErrorMsg() . "</b></span><BR>";
							echo "<span style=\"color: blue;\"><b># SQL></b> The record for member_name: <b>" . $insertrosterrecord['member_name'] . "</b> was not updated <b>>>> SAME <<<<</b><BR></span><BR>";
						} else {
							echo "<span style=\"color: red;\"><b># SQL> Error Message: " . $db_eqdkp->ErrorMsg() . "</b></span><BR>";
						}
					} elseif ($db_eqdkp->ErrorMsg() != "Query was empty") {
						$errorarray[$errorcount] = "<span style=\"color: red;\"><b># SQL> Error Message: " . $db_eqdkp->ErrorMsg() . "</b></span><BR>";
						$errorcount++;
					}
				} else {
					if ($debug) {
						echo "<span style=\"color: green;\"><b># SQL> The Record was succesfully updated for member_name: " . $insertrosterrecord['member_name'] . " with member_id: " . $rostermember['member_id'] . ".</b></span><BR>";
					}
				}
			} else {
				if ($debug) {
					echo "<span style=\"color: red;\"><b># SQL> Error Message: " . $db_eqdkp->ErrorMsg() . "</b></span><BR>";
					echo "<span style=\"color: red;\"><b># SQL> </b>The member_id: " . $rostermember['member_id'] . "<b> does NOT Exist, but the member_name: <b>" . $insertrosterrecord['member_name'] . "</b> DOES EXIST!!!!</span><BR>";
				} else {
					$errorarray[$errorcount] = "<span style=\"color: red;\"><b># SQL> Error Message: " . $db_eqdkp->ErrorMsg() . "</b></span><BR><span style=\"color: red;\"><b># SQL> </b>The member_id: " . $rostermember['member_id'] . "<b> does NOT Exist, but the member_name: <b>" . $insertrosterrecord['member_name'] . "</b> DOES EXIST!!!!</span><BR>";
					$errorcount++;
				}
			}
		} else {
			if ($debug) {
				echo "<span style=\"color: green;\"><b># SQL> The Record was succesfully inserted for member_name: " . $insertrosterrecord['member_name'] . " with Roster member_id: " . $rostermember['member_id'] . ".</b></span><BR>";
			}
		}
	}
}

?>
